
/*  checker.c
 *  This program texture maps a checkerboard image onto
 *  two rectangles.
 */

#include <stdlib.h>
#include <stdio.h>

#include <mgl.h>

mglTexture *chessTexture;

void display_mgl (void)
{
  mglBegin ();
  mglClearScreen (mglBlack);
  mglSetTextureZoom (8);
  mglDrawTexture (chessTexture, 25, 250);
  mglEnd ();

  glDisable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);

  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, 1.0, 1.0, 30.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glTranslatef(0.0, 0.0, -3.6);

  mglChangeTexture (chessTexture);

  glEnable (GL_TEXTURE_2D);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0, 0.0); glVertex3f(1.0, -1.0, 0.0);
  glTexCoord2f(0.0, 1.0); glVertex3f(1.0, 1.0, 0.0);
  glTexCoord2f(1.0, 1.0); glVertex3f(2.41421, 1.0, -1.41421);
  glTexCoord2f(1.0, 0.0); glVertex3f(2.41421, -1.0, -1.41421);
  glEnd();
}


void keyboard_mgl (int key)
{
   switch (key) {
      case 27:
         exit(0);
         break;
      default:
         break;
   }
}


int main(int argc, char** argv)
{
  mglVirtualWidth = mglVirtualHeight = 1000;
  mglOpenWindow (argv [0], 100, 100, 250, 250);

  chessTexture = mglLoadTexture ("../data/examples/checker.tga", 0, GL_NEAREST);

  mglSetDisplayHandler (display_mgl);
  mglSetKeyboardHandler (keyboard_mgl);

  mglRun ();

  return 0; 
}
